/**
 * Test case for runNodeunit.
 * Runs with nodeunit.
 */

var runNodeunit = require('../lib/run_nodeunit.js'),
    path = require('path'),
    mkdirp = require('mkdirp'),
    fs = require('fs'),
    injectmock = require('injectmock');

var tmpDir = path.resolve(__dirname, 'tmp');

exports.setUp = function (done) {
    mkdirp.sync(tmpDir);
    //injectmock(console, 'log', injectmock.noop);
    done();
};
exports.tearDown = function (done) {
    injectmock.restoreAll();
    done();
};

exports['Run nodeunit'] = function (test) {
    var filename = path.resolve(tmpDir, 'mock-test-' + new Date().getTime() + '.js');
    fs.writeFileSync(filename, 'exports.case01=function(test){test.ok(1>0);test.done()};');
    runNodeunit(filename, {}, function (err) {
        test.ifError(err);
        fs.unlinkSync(filename);
        test.done();
    });
};

exports['Handle invalid reporter.'] = function (test) {
    var filename = path.resolve(tmpDir, 'mock-test-' + new Date().getTime() + '.js');
    fs.writeFileSync(filename, 'exports.case01=function(test){test.ok(1>0);test.done()};');
    runNodeunit(filename, {
        reporter: '__invalid_reporter__'
    }, function (err) {
        test.ok(!!err);
        test.done();
    });
};
